
package com.google.javascript.jscomp;

import com.google.common.collect.ImmutableList;
import com.google.common.collect.ImmutableMultiset;
import com.google.javascript.jscomp.deps.ModuleLoader;
import javax.annotation.Generated;
import javax.annotation.Nullable;

@Generated("com.google.auto.value.processor.AutoValueProcessor")
 final class AutoValue_ModuleMetadataMap_ModuleMetadata extends ModuleMetadataMap.ModuleMetadata {

  private final ModuleMetadataMap.ModuleType moduleType;
  private final boolean usesClosure;
  private final boolean isTestOnly;
  private final ImmutableMultiset<String> googNamespaces;
  private final ImmutableMultiset<String> requiredGoogNamespaces;
  private final ImmutableMultiset<String> requiredTypes;
  private final ImmutableMultiset<String> es6ImportSpecifiers;
  private final ImmutableList<ModuleMetadataMap.ModuleMetadata> nestedModules;
  private final ModuleLoader.ModulePath path;

  private AutoValue_ModuleMetadataMap_ModuleMetadata(
      ModuleMetadataMap.ModuleType moduleType,
      boolean usesClosure,
      boolean isTestOnly,
      ImmutableMultiset<String> googNamespaces,
      ImmutableMultiset<String> requiredGoogNamespaces,
      ImmutableMultiset<String> requiredTypes,
      ImmutableMultiset<String> es6ImportSpecifiers,
      ImmutableList<ModuleMetadataMap.ModuleMetadata> nestedModules,
      @Nullable ModuleLoader.ModulePath path) {
    this.moduleType = moduleType;
    this.usesClosure = usesClosure;
    this.isTestOnly = isTestOnly;
    this.googNamespaces = googNamespaces;
    this.requiredGoogNamespaces = requiredGoogNamespaces;
    this.requiredTypes = requiredTypes;
    this.es6ImportSpecifiers = es6ImportSpecifiers;
    this.nestedModules = nestedModules;
    this.path = path;
  }

  @Override
  public ModuleMetadataMap.ModuleType moduleType() {
    return moduleType;
  }

  @Override
  public boolean usesClosure() {
    return usesClosure;
  }

  @Override
  public boolean isTestOnly() {
    return isTestOnly;
  }

  @Override
  public ImmutableMultiset<String> googNamespaces() {
    return googNamespaces;
  }

  @Override
  public ImmutableMultiset<String> requiredGoogNamespaces() {
    return requiredGoogNamespaces;
  }

  @Override
  public ImmutableMultiset<String> requiredTypes() {
    return requiredTypes;
  }

  @Override
  public ImmutableMultiset<String> es6ImportSpecifiers() {
    return es6ImportSpecifiers;
  }

  @Override
  ImmutableList<ModuleMetadataMap.ModuleMetadata> nestedModules() {
    return nestedModules;
  }

  @Nullable
  @Override
  public ModuleLoader.ModulePath path() {
    return path;
  }

  @Override
  public String toString() {
    return "ModuleMetadata{"
        + "moduleType=" + moduleType + ", "
        + "usesClosure=" + usesClosure + ", "
        + "isTestOnly=" + isTestOnly + ", "
        + "googNamespaces=" + googNamespaces + ", "
        + "requiredGoogNamespaces=" + requiredGoogNamespaces + ", "
        + "requiredTypes=" + requiredTypes + ", "
        + "es6ImportSpecifiers=" + es6ImportSpecifiers + ", "
        + "nestedModules=" + nestedModules + ", "
        + "path=" + path
        + "}";
  }

  @Override
  public boolean equals(Object o) {
    if (o == this) {
      return true;
    }
    if (o instanceof ModuleMetadataMap.ModuleMetadata) {
      ModuleMetadataMap.ModuleMetadata that = (ModuleMetadataMap.ModuleMetadata) o;
      return (this.moduleType.equals(that.moduleType()))
           && (this.usesClosure == that.usesClosure())
           && (this.isTestOnly == that.isTestOnly())
           && (this.googNamespaces.equals(that.googNamespaces()))
           && (this.requiredGoogNamespaces.equals(that.requiredGoogNamespaces()))
           && (this.requiredTypes.equals(that.requiredTypes()))
           && (this.es6ImportSpecifiers.equals(that.es6ImportSpecifiers()))
           && (this.nestedModules.equals(that.nestedModules()))
           && ((this.path == null) ? (that.path() == null) : this.path.equals(that.path()));
    }
    return false;
  }

  @Override
  public int hashCode() {
    int h = 1;
    h *= 1000003;
    h ^= this.moduleType.hashCode();
    h *= 1000003;
    h ^= this.usesClosure ? 1231 : 1237;
    h *= 1000003;
    h ^= this.isTestOnly ? 1231 : 1237;
    h *= 1000003;
    h ^= this.googNamespaces.hashCode();
    h *= 1000003;
    h ^= this.requiredGoogNamespaces.hashCode();
    h *= 1000003;
    h ^= this.requiredTypes.hashCode();
    h *= 1000003;
    h ^= this.es6ImportSpecifiers.hashCode();
    h *= 1000003;
    h ^= this.nestedModules.hashCode();
    h *= 1000003;
    h ^= (path == null) ? 0 : this.path.hashCode();
    return h;
  }

  static final class Builder extends ModuleMetadataMap.ModuleMetadata.Builder {
    private ModuleMetadataMap.ModuleType moduleType;
    private Boolean usesClosure;
    private Boolean isTestOnly;
    private ImmutableMultiset.Builder<String> googNamespacesBuilder$;
    private ImmutableMultiset<String> googNamespaces;
    private ImmutableMultiset.Builder<String> requiredGoogNamespacesBuilder$;
    private ImmutableMultiset<String> requiredGoogNamespaces;
    private ImmutableMultiset.Builder<String> requiredTypesBuilder$;
    private ImmutableMultiset<String> requiredTypes;
    private ImmutableMultiset.Builder<String> es6ImportSpecifiersBuilder$;
    private ImmutableMultiset<String> es6ImportSpecifiers;
    private ImmutableList.Builder<ModuleMetadataMap.ModuleMetadata> nestedModulesBuilder$;
    private ImmutableList<ModuleMetadataMap.ModuleMetadata> nestedModules;
    private ModuleLoader.ModulePath path;
    Builder() {
    }
    @Override
    public ModuleMetadataMap.ModuleMetadata.Builder moduleType(ModuleMetadataMap.ModuleType moduleType) {
      if (moduleType == null) {
        throw new NullPointerException("Null moduleType");
      }
      this.moduleType = moduleType;
      return this;
    }
    @Override
    public ModuleMetadataMap.ModuleType moduleType() {
      if (moduleType == null) {
        throw new IllegalStateException("Property \"moduleType\" has not been set");
      }
      return moduleType;
    }
    @Override
    public ModuleMetadataMap.ModuleMetadata.Builder usesClosure(boolean usesClosure) {
      this.usesClosure = usesClosure;
      return this;
    }
    @Override
    public ModuleMetadataMap.ModuleMetadata.Builder isTestOnly(boolean isTestOnly) {
      this.isTestOnly = isTestOnly;
      return this;
    }
    @Override
    public ImmutableMultiset.Builder<String> googNamespacesBuilder() {
      if (googNamespacesBuilder$ == null) {
        googNamespacesBuilder$ = ImmutableMultiset.builder();
      }
      return googNamespacesBuilder$;
    }
    @Override
    public ImmutableMultiset.Builder<String> requiredGoogNamespacesBuilder() {
      if (requiredGoogNamespacesBuilder$ == null) {
        requiredGoogNamespacesBuilder$ = ImmutableMultiset.builder();
      }
      return requiredGoogNamespacesBuilder$;
    }
    @Override
    public ImmutableMultiset.Builder<String> requiredTypesBuilder() {
      if (requiredTypesBuilder$ == null) {
        requiredTypesBuilder$ = ImmutableMultiset.builder();
      }
      return requiredTypesBuilder$;
    }
    @Override
    public ImmutableMultiset.Builder<String> es6ImportSpecifiersBuilder() {
      if (es6ImportSpecifiersBuilder$ == null) {
        es6ImportSpecifiersBuilder$ = ImmutableMultiset.builder();
      }
      return es6ImportSpecifiersBuilder$;
    }
    @Override
    public ImmutableList.Builder<ModuleMetadataMap.ModuleMetadata> nestedModulesBuilder() {
      if (nestedModulesBuilder$ == null) {
        nestedModulesBuilder$ = ImmutableList.builder();
      }
      return nestedModulesBuilder$;
    }
    @Override
    public ModuleMetadataMap.ModuleMetadata.Builder path(@Nullable ModuleLoader.ModulePath path) {
      this.path = path;
      return this;
    }
    @Override
    public ModuleMetadataMap.ModuleMetadata build() {
      if (googNamespacesBuilder$ != null) {
        this.googNamespaces = googNamespacesBuilder$.build();
      } else if (this.googNamespaces == null) {
        this.googNamespaces = ImmutableMultiset.of();
      }
      if (requiredGoogNamespacesBuilder$ != null) {
        this.requiredGoogNamespaces = requiredGoogNamespacesBuilder$.build();
      } else if (this.requiredGoogNamespaces == null) {
        this.requiredGoogNamespaces = ImmutableMultiset.of();
      }
      if (requiredTypesBuilder$ != null) {
        this.requiredTypes = requiredTypesBuilder$.build();
      } else if (this.requiredTypes == null) {
        this.requiredTypes = ImmutableMultiset.of();
      }
      if (es6ImportSpecifiersBuilder$ != null) {
        this.es6ImportSpecifiers = es6ImportSpecifiersBuilder$.build();
      } else if (this.es6ImportSpecifiers == null) {
        this.es6ImportSpecifiers = ImmutableMultiset.of();
      }
      if (nestedModulesBuilder$ != null) {
        this.nestedModules = nestedModulesBuilder$.build();
      } else if (this.nestedModules == null) {
        this.nestedModules = ImmutableList.of();
      }
      String missing = "";
      if (this.moduleType == null) {
        missing += " moduleType";
      }
      if (this.usesClosure == null) {
        missing += " usesClosure";
      }
      if (this.isTestOnly == null) {
        missing += " isTestOnly";
      }
      if (!missing.isEmpty()) {
        throw new IllegalStateException("Missing required properties:" + missing);
      }
      return new AutoValue_ModuleMetadataMap_ModuleMetadata(
          this.moduleType,
          this.usesClosure,
          this.isTestOnly,
          this.googNamespaces,
          this.requiredGoogNamespaces,
          this.requiredTypes,
          this.es6ImportSpecifiers,
          this.nestedModules,
          this.path);
    }
  }

}
